{***********************************************************************
SORCUS

      DEMO1
      Borland Delphi 3.0 project

      PURPOSE
      Shows the handling of a MODULAR-4/486 board from a PC
      with Windows NT / Windows 95 and Borland Delphi 3.0

      AUTHORS
      Dipl.-Ing. J. Schaefer

      VERSION
      See history

      COPYRIGHTS
      SORCUS Computer GmbH 1998
      All Rights Reserved

***********************************************************************}

{***********************************************************************
SORCUS

      DESCRIPTION:
      - Board number 0 can be reseted. The ROM OsX will be loaded.
      - The local LEDs can be switched on and off.
      - If an error occurs, the error handler shows a message box.

***********************************************************************}

{***********************************************************************
SORCUS

      HISTORY:
      09.09.1998 (JS):
      - creation of this file and the corresponding project.

***********************************************************************}

{$define _MLXW32_}

unit Unit1;

interface

{**********************************************************
SORCUS
      Use MLXW32
**********************************************************}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MLXW32, MLXTYPE, StdCtrls, ExtCtrls;

type
  TFormMain = class(TForm)
    ButtonResetBoard0: TButton;
    ButtonLedOn: TButton;
    ButtonLedOff: TButton;
    procedure ButtonResetBoard0Click(Sender: TObject);
    procedure ButtonLedOnClick(Sender: TObject);
    procedure ButtonLedOffClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FormMain: TFormMain;

implementation

{$R *.DFM}



{**********************************************************
SORCUS
      MyErrorHandler

      Implementation of the error handler.
**********************************************************}
procedure MyErrorHandler; far;
begin
     MessageDlg('Error Handler', mtError, [mbYes], 0);
     ml8_clear();
end;



{**********************************************************
SORCUS
      ButtonResetBoard0Click

      Reset board 0.
**********************************************************}
procedure TFormMain.ButtonResetBoard0Click(Sender: TObject);
var
   strOsX : str80;
   wStatus : word;
begin
     {set OsX}
     strOsX := 'ROM';

     {reset board 0}
     wStatus := ml8_reset(0, 0, 1, 0, 0, @MyErrorHandler, strOsX, 300);

     {check if reset was successful}
     if (wStatus <> 0) then
     begin
          MessageDlg('Reset Error', mtError, [mbYes], 0);
     end
     else
     begin
          MessageDlg('Reset OK', mtInformation, [mbYes], 0);
     end;

end;



{**********************************************************
SORCUS
      ButtonLedOnClick

      Switch the local led on.
**********************************************************}
procedure TFormMain.ButtonLedOnClick(Sender: TObject);
begin
     ml8_local_led_on();
end;



{**********************************************************
SORCUS
      ButtonLedOffClick

      Switch the local led off
**********************************************************}
procedure TFormMain.ButtonLedOffClick(Sender: TObject);
begin
     ml8_local_led_off();
end;


end.
