{********************************************************************
*  This is the implementation source file to build the libraries
*  for following platforms:
*
*  Board:               ML8 - MODULAR-4/486
*
*  Operating Systems:   Windows 95
*                       Windows NT
*
*  Author:              Dipl.-Ing. H.Doersam
*
*  Last Change:         21/07/98
*
*  Copyrights           SORCUS Computer GmbH 1997, 1998
*                       All rights reserved
*
********************************************************************}



{ ***** STARTING/ENDING OF AN APPLICATION ***** }

PROCEDURE   ml8_bib_startup
            (language: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_init_bib
            (card, adr, mode, IRQ_channel, DMA_channel: WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_init_test: WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_init_io
            (microchannel: BYTE; optional: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    Cml8_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; OSName: PChar;
            timeout: WORD): WORD;
            EXTERNAL DLL_REF NAME 'ml8_reset';

FUNCTION    ml8_reset
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; VAR OSName: str80;
            timeout: WORD): WORD;
VAR   OsX   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(OsX, OSName, 80);
   ml8_reset := Cml8_reset
      (card, adr, mode, IRQ_channel, DMA_channel,
      error_handler, OsX, timeout);
END;

FUNCTION    ml8_start
            (card, adr, mode, IRQ_channel, DMA_channel: WORD;
            error_handler: POINTER; timeout: WORD): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_exit;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_exit_card
            (card: WORD);
            EXTERNAL DLL_REF;

{ ***** VERSION MANAGEMENT ***** }

PROCEDURE   Cml8_get_bib_version
            (version: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_bib_version';

PROCEDURE   ml8_get_bib_version
            (VAR version: str80);
VAR ver: ARRAY [0..80] OF CHAR;
BEGIN
   Cml8_get_bib_version(ver);
   ml_pstr(version, ver, 80);
END;

PROCEDURE   Cml8_get_os_version
            (version: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_os_version';

PROCEDURE   ml8_get_os_version
            (VAR version: str80);
VAR ver: ARRAY [0..80] OF CHAR;
BEGIN
   Cml8_get_os_version(ver);
   ml_pstr(version, ver, 80);
END;

PROCEDURE   ml8_get_lib_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_mlxdrv_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_osx_version
            (VAR pulVersion: LONGINT; VAR pulDate: LONGINT);
            EXTERNAL DLL_REF;

{ ***** CARD SELECTION ***** }

PROCEDURE   ml8_select_card
            (card: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_selected_card: WORD;
            EXTERNAL DLL_REF;

{ ***** TIMEOUT CONTROL ***** }

PROCEDURE   ml8_auto_timeout;
            EXTERNAL DLL_REF;

FUNCTION    ml8_propose_timeout
            (tenthsec: WORD): WORD;
            EXTERNAL DLL_REF;
{
PROCEDURE   ml8_set_timeout
            (timeout: WORD);
            EXTERNAL DLL_REF;
}
PROCEDURE   ml8_change_timeout(timeout: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_timeout: WORD;
            EXTERNAL DLL_REF;

{ ***** INSTALLING REAL TIME PROGRAMS ***** }

FUNCTION    Cml8_transfer_and_install
            (pgmname: PChar; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_transfer_and_install';

FUNCTION    ml8_transfer_and_install
            (pgmname: str80; usage, task, programnr,
            interruptnr: WORD; flag, datasize: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml8_transfer_and_install := Cml8_transfer_and_install
      (pgm, usage, task, programnr, interruptnr, flag, datasize);
END;

PROCEDURE   ml8_install_task
            (task, programnr, interruptnr: WORD;
            flag, datasize, adr: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_start_pgm;
            EXTERNAL DLL_REF;

FUNCTION    Cml8_transfer_pgm
            (task, usage: WORD; pgmname: PChar;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_transfer_pgm';

FUNCTION    ml8_transfer_pgm
            (task, usage: WORD; pgmname: str80;
            VAR loadadr: LONGINT; VAR prepadr: LONGINT;
            VAR flag: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml8_transfer_pgm := Cml8_transfer_pgm
      (task, usage, pgm, loadadr, prepadr, flag);
END;

FUNCTION    Cml8_enable_remote_debug
            (task: WORD; pgmname: PChar; loadadr, prepadr: LONGINT): WORD;
            EXTERNAL DLL_REF NAME 'ml8_enable_remote_debug';

FUNCTION    ml8_enable_remote_debug
            (task: WORD; pgmname: str80; loadadr, prepadr: LONGINT): WORD;
VAR   pgm   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(pgm, pgmname, 80);
   ml8_enable_remote_debug := Cml8_enable_remote_debug(task, pgm, loadadr, prepadr);
END;

FUNCTION    ml8_send_macro (CB, format: BYTE; n, m: WORD; VAR b; VAR a): WORD;
            EXTERNAL DLL_REF;

FUNCTION    Cml8_load_op
            (osname: PChar): WORD;
            EXTERNAL DLL_REF NAME 'ml8_load_op';

FUNCTION    ml8_load_op
            (VAR osname: str80): WORD;
VAR   op    :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(op, osname, 80);
   ml8_load_op := Cml8_load_op(op);
END;

{ ***** INTERRUPT HANDLING / SERVICE REQUESTS ***** }

PROCEDURE   ml8_set_service
            (ml8_servProc: POINTER);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_suspend_requests;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_allow_requests;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_macro_interruptible
            (on_off: BOOLEAN);
            EXTERNAL DLL_REF;

FUNCTION    ml8_message_available: BOOLEAN;
            EXTERNAL DLL_REF;

FUNCTION    ml8_poll_request: BOOLEAN;
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_message: WORD;
            EXTERNAL DLL_REF;

{ ***** ERROR HANDLING ***** }

PROCEDURE   ml8_set_error_handling
            (error_handling_proc: POINTER);
            EXTERNAL DLL_REF;

PROCEDURE   Cml8_get_error_info
            (VAR err_rec: ml8_error_info_type);
            EXTERNAL DLL_REF NAME 'ml8_get_error_info';

PROCEDURE   ml8_get_error_info(VAR err_rec: ml8_error_info_type);
VAR   markmsg  :  str80;
      errmsg   :  str80;
      hlp      :  PChar;
BEGIN
   Cml8_get_error_info(err_rec);
   hlp := @err_rec.errormessage[0];
   ml_pstr(errmsg, hlp, 80);
   hlp := @err_rec.markmessage[0];
   ml_pstr(markmsg, hlp, 80);
   err_rec.markmessage  := markmsg;
   err_rec.errormessage := errmsg;
END;

PROCEDURE   ml8_get_error_class_and_code
            (VAR error_class: BYTE; VAR error_code: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml8_watch_error
            (usInfoType: WORD): LONGINT;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_call_user_error;
            EXTERNAL DLL_REF;

PROCEDURE   Cml8_make_err_msg(s: PChar; errclass, errcode: BYTE);
            EXTERNAL DLL_REF NAME 'ml8_make_err_msg';

PROCEDURE   ml8_make_err_msg
            (VAR s:str80; errclass, errcode: BYTE);
VAR   strg  :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(strg, s, 80);
   Cml8_make_err_msg(strg, errclass, errcode);
END;

PROCEDURE   ml8_clear_error;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_max_error_retry
            (max: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_error_repeat_test: BOOLEAN;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_repeat_macro
            (rpm: BOOLEAN);
            EXTERNAL DLL_REF;

FUNCTION    ml8_clear: WORD;
            EXTERNAL DLL_REF;

PROCEDURE   Cml8_set_error_info
            (VAR err_rec: ml8_error_info_type);
            EXTERNAL DLL_REF NAME 'ml8_set_error_info';

PROCEDURE   ml8_set_error_info
            (VAR err_rec: ml8_error_info_type);
VAR   markmsg  :  str80;
      errmsg   :  str80;
      hlp      :  PChar;
BEGIN
   errmsg  := err_rec.errormessage;
   markmsg := err_rec.markmessage;
   hlp := @err_rec.errormessage[0];
   ml_cstr(hlp, errmsg, 80);
   hlp := @err_rec.markmessage[0];
   ml_cstr(hlp, markmsg, 80);
   Cml8_set_error_info(err_rec);
END;

PROCEDURE   ml8_set_mark
            (mark: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_mark: WORD;
            EXTERNAL DLL_REF;

PROCEDURE   Cml8_set_error_message
            (errormessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_set_error_message';

PROCEDURE   ml8_set_error_message
            (VAR errormessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(msg, errormessage, 80);
   Cml8_set_error_message(msg);
END;

PROCEDURE   Cml8_get_error_message
            (errormessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_error_message';

PROCEDURE   ml8_get_error_message
            (VAR errormessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   Cml8_get_error_message(msg);
   ml_pstr(errormessage, msg, 80);
END;

PROCEDURE   Cml8_set_mark_message
            (markmessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_set_mark_message';

PROCEDURE   ml8_set_mark_message
            (VAR markmessage: str80);
            VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(msg, markmessage, 80);
   Cml8_set_mark_message(msg);
END;

PROCEDURE   Cml8_get_mark_message
            (markmessage: PChar);
            EXTERNAL DLL_REF NAME 'ml8_get_mark_message';

PROCEDURE   ml8_get_mark_message
            (VAR markmessage: str80);
VAR msg: ARRAY [0..80] OF CHAR;
BEGIN
   Cml8_get_mark_message(msg);
   ml_pstr(markmessage, msg, 80);
END;



{ ***** COMMUNICATION CHECK ***** }

FUNCTION    ml8_reacting: BOOLEAN;
            EXTERNAL DLL_REF;

FUNCTION    ml8_type_check: BYTE;
            EXTERNAL DLL_REF;

FUNCTION    ml8_prog_in_rom
            (pgm: WORD): BOOLEAN;
            EXTERNAL DLL_REF;
{
PROCEDURE   ml8_reset_dlp;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_dlp;
            EXTERNAL DLL_REF;
}

{ ***** READ/WRITE RAM ***** }

PROCEDURE   ml8_set_ram_pointer
            (adr: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_ram
            (size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_ram
            (size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_memory
            (start_adr: LONGINT; size: WORD;
            VAR data_ptr);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_memory
            (start_adr: LONGINT; size: WORD;
            VAR data_ptr);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_physical_address
            (ulSegOff: LONGINT): LONGINT;
            EXTERNAL DLL_REF;

{ ***** PORT I/O ***** }

FUNCTION    ml8_in8_port
            (port: WORD): BYTE;
            EXTERNAL DLL_REF;

FUNCTION    ml8_in16_port
            (port: WORD): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_out8_port
            (port: WORD; data_var: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_out16_port
            (port: WORD; data_var: WORD);
            EXTERNAL DLL_REF;

{ ***** READ/WRITE EEPROM ***** }

FUNCTION    ml8_read_eeprom_direct
            (modul, reladr: BYTE): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_eeprom_copy
            (modul, reladr: BYTE): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_eeprom_direct
            (modul, reladr: BYTE; data_var: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_eeprom_copy
            (modul, reladr: BYTE; data_var: WORD);
            EXTERNAL DLL_REF;

{ ***** LED CONTROL ***** }

PROCEDURE   ml8_local_led_on;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_external_led_on;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_local_led_off;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_external_led_off;
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_local_led_status: BYTE;
            EXTERNAL DLL_REF;

{ ***** REAL TIME CLOCK ***** }

PROCEDURE   ml8_set_rtc_mode
            (mode: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_rtc_status: BYTE;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_date_and_time
            (year, month, day, dow, hour, min, sec: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_set_date_and_time_2000
            (year, month, day, dow, hour, min, sec: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_time
            (VAR hour, min, sec: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_date_and_time
            (VAR year, month, day, dow, hour, min, sec: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_date_and_time_2000
            (VAR year, month, day, dow, hour, min, sec: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_rtc_date_code: LONGINT;
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_rtc_time_code: LONGINT;
            EXTERNAL DLL_REF;

{ ***** TASK/PROGRAM INFORMATION ***** }

FUNCTION    ml8_get_task_status
            (task: WORD): BYTE;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_task_info
            (task: WORD; callnr: WORD; VAR result: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_int_task
            (inter: WORD; VAR task: WORD; VAR dummy: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_task_number
            (prognumber: WORD; VAR installnr: WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_pgm_installed
            (task: WORD): WORD;
            EXTERNAL DLL_REF;

{ ***** CACHE CONTROL ***** }

PROCEDURE   ml8_cache_control
            (mode: BYTE);
            EXTERNAL DLL_REF;

{ ***** TASK CONTROL ***** }

PROCEDURE   ml8_wakeup_task
            (task: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_sleep_task
            (task: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_wakeup_ti_task
            (task: WORD; priority: BYTE; count, intervall, holdoff: LONGINT);
            EXTERNAL DLL_REF;


{ ***** CALL PROCEDURE/FUNCTION OF A TASK ***** }

PROCEDURE   ml8_call_proc
            (task, procedurenr: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_call_func
            (task, func ,outsize: WORD; VAR outdata_var;
            maxinsize: WORD; VAR insize: WORD; VAR indata_var;
            VAR error: BYTE);
            EXTERNAL DLL_REF;

{ ***** READ/WRITE PARAMETER OF A TASK ***** }

FUNCTION    ml8_read_par_byte
            (task, start: WORD):BYTE;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_par_word
            (task, start: WORD):WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_par_dword
            (task, start: WORD; VAR datavar: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_par_block
            (task, start, size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_par_byte
            (task, start: WORD; data:BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_par_word
            (task, start, data: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_par_dword
            (task, start: WORD; datavar: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_par_block
            (task, start, size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

{ ***** READ/WRITE DATA AREA OF A TASK ***** }

PROCEDURE   ml8_reset_r_pointer
            (task: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_move_r_pointer
            (task: WORD; offset: LONGINT);
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_data_byte
            (task: WORD): BYTE;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_data_word
            (task: WORD): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_data_dword
            (task: WORD; VAR datavar: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_data_block
            (task, size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_data
            (task: WORD; rel_ofs: LONGINT; size: WORD; VAR data);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_reset_w_pointer
            (task: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_move_w_pointer
            (task: WORD; offset: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_data_byte
            (task: WORD; data: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_data_word
            (task, data: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_data_dword
            (task: WORD; datavar: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_data_block
            (task, size: WORD; VAR data_var);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_write_data
            (task: WORD; rel_ofs: LONGINT; size: WORD; VAR data);
            EXTERNAL DLL_REF;

{ ***** BUFFER ***** }

FUNCTION    ml8_create_buffer
            (task: WORD; strategy: BYTE; align: BYTE; usage: WORD;
            VAR size: LONGINT; VAR handle:LONGINT): BYTE;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_delete_buffer
            (buffer: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_clear_buffer
            (buffer: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_buffer_status
            (buffer: LONGINT; VAR freesize: LONGINT;
            VAR usedsize: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_prev_buffer_status
            (VAR freesize: WORD; VAR usedsize: WORD);
            EXTERNAL DLL_REF;

FUNCTION    ml8_set_buffer
            (buffer: LONGINT; strategy: BYTE; VAR size: WORD;
            VAR datavar): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_buffer
            (buffer: LONGINT; strategy:BYTE; VAR size:WORD;
            VAR datavar): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_write_buffer_byte
            (buffer: LONGINT; data:BYTE): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_write_buffer_word
            (buffer: LONGINT; data:WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_write_buffer_dword
            (buffer: LONGINT; data:LONGINT): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_buffer_byte
            (buffer: LONGINT; VAR data:BYTE): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_buffer_word
            (buffer: LONGINT; VAR data: WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_read_buffer_dword
            (buffer: LONGINT; VAR data:LONGINT): WORD;
            EXTERNAL DLL_REF;

{ ***** DMA Transfer ****}

FUNCTION        ml8_read_dma
                        (VAR pbuffer; ulBufferSize: LONGINT; VAR pulBytesRead: LONGINT) : WORD;
            EXTERNAL DLL_REF;

FUNCTION        ml8_write_dma
                        (VAR pbuffer; ulBufferSize: LONGINT; VAR pulBytesWritten: LONGINT) : WORD;
            EXTERNAL DLL_REF;


{ ***** MEMORY ALLOCATION ***** }

PROCEDURE   ml8_allocate_ram
            (task, usage: WORD; strategy, align: BYTE;
            VAR size: LONGINT; VAR adr: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_get_free_ram_size
            (align: BYTE; VAR size: LONGINT);
            EXTERNAL DLL_REF;

{ ***** FLASH PROGRAMMING ***** }

PROCEDURE   ml8_set_flash_mode
            (ucDevNo, ucICNo, ucMode, ucOption: BYTE);
            EXTERNAL DLL_REF;

FUNCTION    ml8_get_flash_info
            (ucDevNo, ucICNo, ucMode, ucOption: BYTE): WORD;
            EXTERNAL DLL_REF;

FUNCTION    ml8_erase_flash_sector
            (ucDevNo, ucICNo: BYTE; ulFirstAdr,
            ulLastAdr: LONGINT): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   ml8_program_flash
            (ucDevNo, ucICNo: BYTE; ulStartAdr: LONGINT;
            usSize: WORD; VAR pData);
            EXTERNAL DLL_REF;

PROCEDURE   ml8_read_flash
            (ucDevNo, ucICNo: BYTE; ulStartAdr: LONGINT;
            usSize: WORD; VAR pData);
            EXTERNAL DLL_REF;



{ ***** VERSION, DATE AND TIME CODES ***** }

PROCEDURE   Cml8_create_version_string
            (pacVerStr: PChar; ulVerCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_version_string';

PROCEDURE   ml8_create_version_string
            (VAR pacVerStr: str80; ulVerCode: LONGINT);
VAR   ver   :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml8_create_version_string(ver, ulVerCode);
   ml_pstr(pacVerStr, ver, 20);
END;

PROCEDURE   Cml8_create_date_string
            (pacDateStr: PChar; ulDateCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_date_string';

PROCEDURE   ml8_create_date_string
            (VAR pacDateStr: str80; ulDateCode: LONGINT);
VAR   date  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml8_create_date_string(date, ulDateCode);
   ml_pstr(pacDateStr, date, 20);
END;

PROCEDURE   Cml8_create_time_string
            (pacTimeStr: PChar; ulTimeCode: LONGINT);
            EXTERNAL DLL_REF NAME 'ml8_create_time_string';

PROCEDURE   ml8_create_time_string
            (VAR pacTimeStr: str80; ulTimeCode: LONGINT);
VAR   time  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml8_create_time_string(time, ulTimeCode);
   ml_pstr(pacTimeStr, time, 20);
END;

PROCEDURE   Cml8_create_micro_time_string
            (pacTimeStr: PChar; VAR prcTimeCode: MICRO_TIME_CODE);
            EXTERNAL DLL_REF NAME 'ml8_create_micro_time_string';

PROCEDURE   ml8_create_micro_time_string
            (VAR pacTimeStr: str80; VAR prcTimeCode: MICRO_TIME_CODE);
VAR   time  :  ARRAY [0..20] OF CHAR;
BEGIN
   Cml8_create_micro_time_string(time, prcTimeCode);
   ml_pstr(pacTimeStr, time, 20);
END;

{ ***** SPECIAL FUNCTIONS ***** }

FUNCTION    ml8_get_exe_size (VAR Name: String; VAR Size: LongInt):
            Word;
            EXTERNAL DLL_REF;



{ ***** MDD FUNCTIONS ***** }


PROCEDURE   mdd8_get_version
            (usMDD: WORD; VAR pulVersion: LONGINT;
            VAR pulDate: LONGINT);
            EXTERNAL DLL_REF;

FUNCTION    mdd8_open_channel
            (usMDD, usStrucSize: WORD; VAR pCPS): HMDD8;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_open_channel_callback
            (usMDD, usStrucSize: WORD; VAR pCPS;
            param: LONGINT; pfnCbFunc : POINTER; mode: WORD): HMDD8;
            EXTERNAL DLL_REF;

PROCEDURE   Cmdd8_read_infotext
            (usMDD, usTxtNr: WORD; ucMaxLen: BYTE;
            pacInfotext: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_read_infotext';

PROCEDURE   mdd8_read_infotext
            (usMDD, usTxtNr: WORD; ucMaxLen: BYTE;
            VAR pacInfotext: str80);
VAR   acTextFromMDD  :  ARRAY [0..80] OF CHAR;
BEGIN
   Cmdd8_read_infotext(usMDD, usTxtNr, ucMaxLen, acTextFromMDD);
   ml_pstr(pacInfotext, acTextFromMDD, 80);
END;

FUNCTION    mdd8_get_device_status
            (usMDD, usDevice, usIndex, usExtIndex: WORD): WORD;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_scan_channel
            (usMDD, usInfoType: WORD; hChannel: HMDD8;
            usCount: WORD; VAR pInfoData): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_reset_driver
            (usMDD: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_write_channel_byte
            (hChannel: HMDD8; ucData: BYTE);
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_write_channel_word
            (hChannel: HMDD8; usData: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_write_channel_dword
            (hChannel: HMDD8; ulData: LONGINT);
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_write_channel_short
            (hChannel: HMDD8; sData: INTEGER);
            EXTERNAL DLL_REF;

FUNCTION    mdd8_write_channel_block
            (hChannel: HMDD8; usCount: WORD; VAR pData): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_trigger_channel
            (hChannel: HMDD8);
            EXTERNAL DLL_REF;

FUNCTION    mdd8_read_channel_byte
            (hChannel: HMDD8): BYTE;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_read_channel_word
            (hChannel: HMDD8): WORD;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_read_channel_dword
            (hChannel: HMDD8): DWORD;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_read_channel_short
            (hChannel: HMDD8): INTEGER;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_read_channel_block
            (hChannel: HMDD8; usCount: WORD; VAR pData): WORD;
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_send_channel_command
            (hChannel: HMDD8; usCmd: WORD);
            EXTERNAL DLL_REF;

PROCEDURE   mdd8_send_channel_control
            (hChannel: HMDD8; usCtrl: WORD; ulCtrlData: LONGINT);
            EXTERNAL DLL_REF;

FUNCTION    mdd8_send_channel_control_block
            (hChannel: HMDD8; usCtrl, usSize: WORD; VAR pCtrlData):
            WORD;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_get_channel_info
            (hChannel: HMDD8; usInfo: WORD): LONGINT;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_get_channel_info_block
            (hChannel: HMDD8; usInfo, usSize: WORD; VAR pInfoData):
            WORD;
            EXTERNAL DLL_REF;

PROCEDURE   Cmdd8_set_channel_caption
            (hChannel: HMDD8; usLen: WORD; pcCaption: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_set_channel_caption';

PROCEDURE   mdd8_set_channel_caption
            (hChannel: HMDD8; usLen: WORD; pcCaption: STRING);
VAR   acCaptionToChannel   :  ARRAY [0..80] OF CHAR;
BEGIN
   ml_cstr(acCaptionToChannel, pcCaption, 80);
   Cmdd8_set_channel_caption
      (hChannel, usLen + 1, acCaptionToChannel);
END;

PROCEDURE   Cmdd8_get_channel_caption
            (hChannel: HMDD8; usLen: WORD; pcCaption: PChar);
            EXTERNAL DLL_REF NAME 'mdd8_set_channel_caption';

PROCEDURE   mdd8_get_channel_caption
            (hChannel: HMDD8; usLen: WORD; VAR pcCaption: STRING);
VAR   acCaptionFromChannel :  ARRAY [0..80] OF CHAR;
BEGIN
   Cmdd8_get_channel_caption
      (hChannel, usLen + 1, acCaptionFromChannel);
   ml_pstr(pcCaption, acCaptionFromChannel, 80);
END;

PROCEDURE   mdd8_close_channel (VAR phChannel: HMDD8);
            EXTERNAL DLL_REF;

FUNCTION    mdd8_check_handle_valid (hChannel: HMDD8): WORD;
            EXTERNAL DLL_REF;

FUNCTION    mdd8_get_diagnosis : WORD;
            EXTERNAL DLL_REF;

FUNCTION    Cml8_set_search_path (pPath: PChar) : LONGINT;
            EXTERNAL DLL_REF NAME 'ml8_set_search_path';

FUNCTION    ml8_set_search_path (pPath: STRING) : LONGINT;
VAR   acPath   :  ARRAY [0..255] OF CHAR;
BEGIN
   ml_cstr(acPath, pPath, 255);
   ml8_set_search_path := Cml8_set_search_path (acPath);
END;

