Attribute VB_Name = "Importbibliothek"
'********************************************************************************
'   ML8BIB.BAS
'
'   IMPORT LIBRARY TO WRITE VISUAL BASIC PROGRAMS WITH THE MODULAR-4
'   (BETA-VERSION!)
'
'   (C) SORCUS COMPUTER HEIDELBERG 1997
'********************************************************************************

    
'   SELECT THE PLATFORM THE PROGRAM SHOULD BE RUN:
    #Const PLATFORM = 1         ' Windows 3.11
'   #Const PLATFORM = 2         ' Windows NT
'   #Const PLATFORM = 3         ' Windows 95


'   number of cards you can handle with the library
Public Const NUMBEROFCARDS = 8

'   definitions for the actual language
Public Const LANGUAGE_C = &H200                 ' C
Public Const LANGUAGE_PASCAL = &H100            ' Pascal

'   stategies for memory allocation (used by ml8_allocate_ram)
Public Const ALLOC_GET_SIZE = 0                 ' get free size of memory
Public Const ALLOC_UP_ABS = 1                   ' BOTTOM UP, all or nothing
Public Const ALLOC_UP_MAX = 2                   ' BOTTOM UP, as much as possible
Public Const ALLOC_DOWN_ABS = 3                 ' TOP DOWN, all or nothing
Public Const ALLOC_DOWN_MAX = 4                 ' TOP DOWN, as much as possible

'   strategies used by buffer operations (ml8_get_buffer, ml8_set_buffer)
Public Const BUFFER_ALL_OR_NOTHING = 0          ' all or nothing
Public Const BUFFER_MAXIMUM = 1                 ' as much as possible
Public Const BUFFER_COPY = 2                    ' view buffer, data stays in buffer
Public Const BUFFER_TRY_MULTIPLE = 4            ' try until data are available

'   constants for the error record
Public Const MAX_ERR_OUT_CMD = 6
Public Const MAX_ERR_IN_CMD = 6
Public Const MAX_ERR_OUT_DATA = 6
Public Const MAX_ERR_IN_DATA = 6

Public Const STATUSMAP_OLD_ERROR_SEND = 1
Public Const STATUSMAP_OLD_ERROR_RECEIVE = 2
Public Const STATUSMAP_ERROR_REQUEST = 64
Public Const STATUSMAP_LIB_NOT_INITIALIZED = 128

'   FLASH: MODES FOR FLASH EPROM CONTROL
Public Const FLASH_GET_CUSTOMER_ID = &H0
Public Const FLASH_GET_DEVICE_ID = &H1
Public Const FLASH_GET_SIZE_INFO = &H2
Public Const FLASH_GET_ORGANIZATION = &H3
Public Const FLASH_CHECK_WRITE_PROTECTED = &H4
Public Const FLASH_GET_ERASE_STATUS = &H5
Public Const FLASH_COPY_EPROM = &H6
Public Const FLASH_GET_SOFT_STATE = &HA
Public Const FLASH_ERASE_ENABLE = &HB
Public Const FLASH_ERASE_DISABLE = &HC
Public Const FLASH_PROGRAM_ENABLE = &HD
Public Const FLASH_PROGRAM_DISABLE = &HE

'   MDD:  FUNCTION NUMBERS
Public Const MDD_NR_RESET_DRIVER = 3
Public Const MDD_NR_GET_VERSION = 6
Public Const MDD_NR_OPEN_CHANNEL = 8
Public Const MDD_NR_READ_INFOTEXT = 9
Public Const MDD_NR_GET_DEVICE_STATUS = 12
Public Const MDD_NR_SCAN_CHANNEL = 13

'   MDD:  CHANNEL COMMANDS
Public Const CMD_CLOSE = &HA0
Public Const CMD_SUSP_WRITE = &HA1
Public Const CMD_CONT_WRITE = &HA2
Public Const CMD_SUSP_READ = &HA3
Public Const CMD_CONT_READ = &HA4
Public Const CMD_RESET = &HA5
Public Const CMD_START = &HA6
Public Const CMD_STOP = &HA7
Public Const CMD_CONTINUE = &HA8
Public Const CMD_LATCH_OUT = &HA9
Public Const CMD_LATCH_IN = &HAA

'   MDD:  CHANNEL CONTROLS
Public Const CTRL_DEVICE = &H60
Public Const CTRL_RW_PTR = &H61
Public Const CTRL_R_PTR = &H62
Public Const CTRL_W_PTR = &H63
Public Const CTRL_CAPTION = &H90

'   MDD:  CHANNEL INFOS
Public Const INFO_STATUS = &H40
Public Const INFO_DATA_TYPE = &H42
Public Const INFO_TRANSFER_MODE = &H43
Public Const INFO_MINSIZE = &H44
Public Const INFO_MAXSIZE = &H45
Public Const INFO_RANGE = &H46
Public Const INFO_RESOLUTION = &H47
Public Const INFO_DEVICE = &H48
Public Const INFO_RW_PTR = &H50
Public Const INFO_R_PTR = &H51
Public Const INFO_W_PTR = &H52
Public Const INFO_CAPTION = &H80

'   MDD:  INFOTEXT NUMBERS (LOW-BYTE = PAGE, HIGH-BYTE = LINE)
Public Const ITNO_DEVICE_NAME = &H0
Public Const ITNO_DEVICE_REVISION = &H100
Public Const ITNO_FIRM_NAME = &H1
Public Const ITNO_AUTHOR_NAME = &H101

'   MDD:  DEVICE STATUS
Public Const DSC_IS_EXCLUSIVE = &HFFFF

'   MDD:  DATA TYPES
Public Const DATA_VOID = &H1
Public Const DATA_BYTE = &H3
Public Const DATA_CHAR = &H4
Public Const DATA_WORD = &H5
Public Const DATA_SHORT = &H6
Public Const DATA_DWORD = &H7
Public Const DATA_LONG = &H8
Public Const DATA_BLOCK = &H9

'   MDD:  TRANSFER MODES
Public Const R_MODE = &H1
Public Const W_MODE = &H2
Public Const RW_MODE = &H3

'   MDD:  PHYSICAL I/O RANGES
Public Const RANGE_VOID = &H1
Public Const RANGE_UPP_312MV5 = &H21
Public Const RANGE_UPP_625MV = &H22
Public Const RANGE_UPP_1V25 = &H23
Public Const RANGE_UPP_2V5 = &H24
Public Const RANGE_UPP_5V = &H25
Public Const RANGE_UPP_10V = &H26
Public Const RANGE_UPN_312MV5 = &H41
Public Const RANGE_UPN_625MV = &H42
Public Const RANGE_UPN_1V25 = &H43
Public Const RANGE_UPN_2V5 = &H44
Public Const RANGE_UPN_5V = &H45
Public Const RANGE_UPN_10V = &H46
Public Const RANGE_BIP_312MV5 = &H61
Public Const RANGE_BIP_625MV = &H62
Public Const RANGE_BIP_1V25 = &H63
Public Const RANGE_BIP_2V5 = &H64
Public Const RANGE_BIP_5V = &H65
Public Const RANGE_BIP_10V = &H66
Public Const RANGE_20MA = &H81

'   MDD:  FLAGS OF THE CHANNEL STATUS REGISTER
Public Const CSR_EXCLUSIVE = &H1
Public Const CSR_HW_FORMAT = &H2
Public Const CSR_OUT_SUSP = &H10000
Public Const CSR_IN_SUSP = &H20000

'   MDD:  DEVICE TYPES
Public Const DEVICE_DIN = &H101
Public Const DEVICE_DOUT = &H102
Public Const DEVICE_DIO = &H103
Public Const DEVICE_AIN_SE = &H201
Public Const DEVICE_AIN_DIFF = &H202
Public Const DEVICE_AOUT = &H203
Public Const DEVICE_TRIG = &H301
Public Const DEVICE_CTRL = &H401
Public Const DEVICE_LED = &H402
Public Const DEVICE_TIMER = &H501
Public Const DEVICE_WATCHDOG = &H503
Public Const DEVICE_COUNTER = &H601
Public Const DEVICE_CLOCK = &H701
Public Const DEVICE_CALENDAR = &H702
Public Const DEVICE_SCC = &H801
Public Const DEVICE_SQRWAVE = &H901
Public Const DEVICE_EEPROM = &HA01
Public Const DEVICE_HW_INT = &HB01

'   MDD:  FLAGS OF A CHANNEL PROPERTY STRUCTURE (CPS)
Public Const CP_EXCLUSIVE = &H1
Public Const CP_HW_FORMAT = &H2

'   MDD:  READ/WRITE MODE (CHANNEL PROPERTY)
Public Const IO_MODE_DIRECT = &H1
Public Const IO_MODE_LATCH = &H2
Public Const IO_MODE_RAM = &H4
Public Const IO_MODE_RAM_LATCH = &H6

'   MDD:  COMMANDS FOR MDD_SCAN_CHANNEL
Public Const SCAN_SERVICE_LIST = 1
Public Const SCAN_CDT = 2
Public Const SCAN_HANDLE = 3
Public Const SCAN_CPS = 4

'   MDD:  MDD SPECIFIC DEFINES
Public Const MD402_OUTPUT_ENABLE_0_7 = &H1
Public Const MD402_OUTPUT_ENABLE_8_15 = &H2
Public Const MD402_OUTPUT_ENABLE_16_23 = &H4
Public Const MD402_OUTPUT_ENABLE_24_31 = &H8
Public Const MD402_OUTPUT_ENABLE_32_39 = &H10
Public Const MD402_POS_TRIGGER = &H1
Public Const MD402_EXT_TRIGGER = &H2
Public Const MD402_ENABLE_INT_0 = &H1
Public Const MD402_ENABLE_INT_1 = &H2
Public Const MD402_ENABLE_INT_2 = &H4
Public Const MD402_ENABLE_INT_3 = &H8

Public Const MOPT1A_CON_DIN_0_IRQ_E = &H1
Public Const MOPT1A_CON_DIN_1_IRQ_B = &H2

Public Const MOPT1B_ENABLE_DOUT_0_15 = &H1
Public Const MOPT1B_WATCHDOG_ENABLE = &H2
Public Const MOPT1B_CON_WATCHDOG_IRQ_B = &H1

Public Const MRU82_ENABLE_DOUT_0_7 = &H1
Public Const MRU82_WATCHDOG_ENABLE = &H1
Public Const MRU82_CON_WATCHDOG_NMI = &H1



'   ***** Declares *****


#If PLATFORM = 2 Then
Declare Sub ml8_bib_startup Lib "nmlxbib.dll" (ByVal varname As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_bib_startup Lib "fmlxbib.dll" (ByVal varname As Integer)
#Else
Declare Sub ml8_bib_startup Lib "wml8bib.dll" (ByVal varname As Integer)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_reset Lib "nmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As String, ByVal varname As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_reset Lib "fmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As String, ByVal varname As Integer) As Integer
#Else
Declare Function ml8_reset Lib "wml8bib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As String, ByVal varname As Integer) As Integer
#End If


#If PLATFORM = 2 Then
Declare Function ml8_start Lib "nmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_start Lib "fmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As Integer) As Integer
#Else
Declare Function ml8_start Lib "wml8bib.dll" (ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, ByVal varname As Integer, lpstring As Long, ByVal varname As Integer) As Integer ' * '
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_select_card Lib "nmlxbib.dll" (ByVal varname As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_select_card Lib "fmlxbib.dll" (ByVal varname As Integer)
#Else
Declare Sub ml8_select_card Lib "wml8bib.dll" (ByVal varname As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_exit_card Lib "nmlxbib.dll" (ByVal varname As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_exit_card Lib "fmlxbib.dll" (ByVal varname As Integer)
#Else
Declare Sub ml8_exit_card Lib "wml8bib.dll" (ByVal varname As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_exit Lib "nmlxbib.dll" ()
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_exit Lib "fmlxbib.dll" ()
#Else
Declare Sub ml8_exit Lib "wml8bib.dll" () ' * '
#End If


#If PLATFORM = 2 Then
Declare Function ml8_reacting Lib "nmlxbib.dll" () As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_reacting Lib "fmlxbib.dll" () As Integer
#Else
Declare Function ml8_reacting Lib "wml8bib.dll" () As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_card_check Lib "nmlxbib.dll" (varname As Byte, varname As Byte, varname As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_card_check Lib "fmlxbib.dll" (varname As Byte, varname As Byte, varname As Byte)
#Else
Declare Sub ml8_card_check Lib "wml8bib.dll" (varname As Byte, varname As Byte, varname As Byte)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_get_os_version Lib "nmlxbib.dll" (ByVal os As String)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_get_os_version Lib "fmlxbib.dll" (ByVal os As String)
#Else
Declare Sub ml8_get_os_version Lib "wml8bib.dll" (ByVal os As String)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_get_bib_version Lib "nmlxbib.dll" (os As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_get_bib_version Lib "fmlxbib.dll" (os As Byte)
#Else
Declare Sub ml8_get_bib_version Lib "wml8bib.dll" (os As Byte)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_transfer_and_install Lib "nmlxbib.dll" (ByVal varname As String, ByVal usage As Integer, ByVal task As Integer, ByVal prgnum As Integer, ByVal interrupt As Integer, ByVal flag As Long, ByVal size As Long) As Integer ' * '
#ElseIf PLATFORM = 3 Then
Declare Function ml8_transfer_and_install Lib "fmlxbib.dll" (ByVal varname As String, ByVal usage As Integer, ByVal task As Integer, ByVal prgnum As Integer, ByVal interrupt As Integer, ByVal flag As Long, ByVal size As Long) As Integer ' * '
#Else
Declare Function ml8_transfer_and_install Lib "wml8bib.dll" (ByVal varname As String, ByVal usage As Integer, ByVal task As Integer, ByVal prgnum As Integer, ByVal interrupt As Integer, ByVal flag As Long, ByVal size As Long) As Integer ' * '
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_get_task_info Lib "nmlxbib.dll" (ByVal task As Integer, ByVal callnr As Integer, result As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_get_task_info Lib "fmlxbib.dll" (ByVal task As Integer, ByVal callnr As Integer, result As Long)
#Else
Declare Sub ml8_get_task_info Lib "wml8bib.dll" (ByVal task As Integer, ByVal callnr As Integer, result As Long)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_get_task_status Lib "nmlxbib.dll" (ByVal task As Integer) As Byte
#ElseIf PLATFORM = 3 Then
Declare Function ml8_get_task_status Lib "fmlxbib.dll" (ByVal task As Integer) As Byte
#Else
Declare Function ml8_get_task_status Lib "wml8bib.dll" (ByVal task As Integer) As Byte
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_wakeup_task Lib "nmlxbib.dll" (ByVal task As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_wakeup_task Lib "fmlxbib.dll" (ByVal task As Integer)
#Else
Declare Sub ml8_wakeup_task Lib "wml8bib.dll" (ByVal task As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_sleep_task Lib "nmlxbib.dll" (ByVal task As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_sleep_task Lib "fmlxbib.dll" (ByVal task As Integer)
#Else
Declare Sub ml8_sleep_task Lib "wml8bib.dll" (ByVal task As Integer)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_get_pgm_installed Lib "nmlxbib.dll" (ByVal task As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_get_pgm_installed Lib "fmlxbib.dll" (ByVal task As Integer) As Integer
#Else
Declare Function ml8_get_pgm_installed Lib "wml8bib.dll" (ByVal task As Integer) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_call_func Lib "nmlxbib.dll" (ByVal task As Integer, ByVal func As Integer, ByVal outsize As Integer, outdata As Any, ByVal maxinsize As Integer, insize As Integer, indata As Any, error As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_call_func Lib "fmlxbib.dll" (ByVal task As Integer, ByVal func As Integer, ByVal outsize As Integer, outdata As Any, ByVal maxinsize As Integer, insize As Integer, indata As Any, error As Byte)
#Else
Declare Sub ml8_call_func Lib "wml8bib.dll" (ByVal task As Integer, ByVal func As Integer, ByVal outsize As Integer, outdata As Any, ByVal maxinsize As Integer, insize As Integer, indata As Any, error As Byte)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_call_proc Lib "nmlxbib.dll" (ByVal task As Integer, ByVal procnum As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_call_proc Lib "fmlxbib.dll" (ByVal task As Integer, ByVal procnum As Integer)
#Else
Declare Sub ml8_call_proc Lib "wml8bib.dll" (ByVal task As Integer, ByVal procnum As Integer)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_par_byte Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer) As Byte
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_par_byte Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer) As Byte
#Else
Declare Function ml8_read_par_byte Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer) As Byte
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_par_word Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_par_word Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer) As Integer
#Else
Declare Function ml8_read_par_word Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_read_par_dword Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, data As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_read_par_dword Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, data As Long)
#Else
Declare Sub ml8_read_par_dword Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, data As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_read_par_block Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_read_par_block Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_read_par_block Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_par_byte Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_par_byte Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Byte)
#Else
Declare Sub ml8_write_par_byte Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Byte)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_par_word Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_par_word Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Integer)
#Else
Declare Sub ml8_write_par_word Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_par_dword Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_par_dword Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Long)
#Else
Declare Sub ml8_write_par_dword Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal data As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_par_block Lib "nmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_par_block Lib "fmlxbib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_write_par_block Lib "wml8bib.dll" (ByVal task As Integer, ByVal start As Integer, ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_reset_r_pointer Lib "nmlxbib.dll" (ByVal task As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_reset_r_pointer Lib "fmlxbib.dll" (ByVal task As Integer)
#Else
Declare Sub ml8_reset_r_pointer Lib "wml8bib.dll" (ByVal task As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_move_r_pointer Lib "nmlxbib.dll" (ByVal task As Integer, ByVal offset As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_move_r_pointer Lib "fmlxbib.dll" (ByVal task As Integer, ByVal offset As Long)
#Else
Declare Sub ml8_move_r_pointer Lib "wml8bib.dll" (ByVal task As Integer, ByVal offset As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_reset_w_pointer Lib "nmlxbib.dll" (ByVal task As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_reset_w_pointer Lib "fmlxbib.dll" (ByVal task As Integer)
#Else
Declare Sub ml8_reset_w_pointer Lib "wml8bib.dll" (ByVal task As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_move_w_pointer Lib "nmlxbib.dll" (ByVal task As Integer, ByVal offset As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_move_w_pointer Lib "fmlxbib.dll" (ByVal task As Integer, ByVal offset As Long)
#Else
Declare Sub ml8_move_w_pointer Lib "wml8bib.dll" (ByVal task As Integer, ByVal offset As Long)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_data_byte Lib "nmlxbib.dll" (ByVal task As Integer) As Byte
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_data_byte Lib "fmlxbib.dll" (ByVal task As Integer) As Byte
#Else
Declare Function ml8_read_data_byte Lib "wml8bib.dll" (ByVal task As Integer) As Byte
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_data_word Lib "nmlxbib.dll" (ByVal task As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_data_word Lib "fmlxbib.dll" (ByVal task As Integer) As Integer
#Else
Declare Function ml8_read_data_word Lib "wml8bib.dll" (ByVal task As Integer) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_read_data_dword Lib "nmlxbib.dll" (ByVal task As Integer, data As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_read_data_dword Lib "fmlxbib.dll" (ByVal task As Integer, data As Long)
#Else
Declare Sub ml8_read_data_dword Lib "wml8bib.dll" (ByVal task As Integer, data As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_read_data_block Lib "nmlxbib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_read_data_block Lib "fmlxbib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_read_data_block Lib "wml8bib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_data_byte Lib "nmlxbib.dll" (ByVal task As Integer, ByVal data As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_data_byte Lib "fmlxbib.dll" (ByVal task As Integer, ByVal data As Byte)
#Else
Declare Sub ml8_write_data_byte Lib "wml8bib.dll" (ByVal task As Integer, ByVal data As Byte)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_data_word Lib "nmlxbib.dll" (ByVal task As Integer, ByVal data As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_data_word Lib "fmlxbib.dll" (ByVal task As Integer, ByVal data As Integer)
#Else
Declare Sub ml8_write_data_word Lib "wml8bib.dll" (ByVal task As Integer, ByVal data As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_data_dword Lib "nmlxbib.dll" (ByVal task As Integer, ByVal data As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_data_dword Lib "fmlxbib.dll" (ByVal task As Integer, ByVal data As Long)
#Else
Declare Sub ml8_write_data_dword Lib "wml8bib.dll" (ByVal task As Integer, ByVal data As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_data_block Lib "nmlxbib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_data_block Lib "fmlxbib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_write_data_block Lib "wml8bib.dll" (ByVal task As Integer, ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_set_ram_pointer Lib "nmlxbib.dll" (ByVal adr As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_set_ram_pointer Lib "fmlxbib.dll" (ByVal adr As Long)
#Else
Declare Sub ml8_set_ram_pointer Lib "wml8bib.dll" (ByVal adr As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_read_ram Lib "nmlxbib.dll" (ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_read_ram Lib "fmlxbib.dll" (ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_read_ram Lib "wml8bib.dll" (ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_ram Lib "nmlxbib.dll" (ByVal size As Integer, data As Any)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_ram Lib "fmlxbib.dll" (ByVal size As Integer, data As Any)
#Else
Declare Sub ml8_write_ram Lib "wml8bib.dll" (ByVal size As Integer, data As Any)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_in8_port Lib "nmlxbib.dll" (ByVal port As Integer) As Byte
#ElseIf PLATFORM = 3 Then
Declare Function ml8_in8_port Lib "fmlxbib.dll" (ByVal port As Integer) As Byte
#Else
Declare Function ml8_in8_port Lib "wml8bib.dll" (ByVal port As Integer) As Byte
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_out8_port Lib "nmlxbib.dll" (ByVal varname As Integer, ByVal varname As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_out8_port Lib "fmlxbib.dll" (ByVal varname As Integer, ByVal varname As Byte)
#Else
Declare Sub ml8_out8_port Lib "wml8bib.dll" (ByVal varname As Integer, ByVal varname As Byte)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_in16_port Lib "nmlxbib.dll" (ByVal port As Integer) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_in16_port Lib "fmlxbib.dll" (ByVal port As Integer) As Integer
#Else
Declare Function ml8_in16_port Lib "wml8bib.dll" (ByVal port As Integer) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_out16_port Lib "nmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_out16_port Lib "fmlxbib.dll" (ByVal varname As Integer, ByVal varname As Integer)
#Else
Declare Sub ml8_out16_port Lib "wml8bib.dll" (ByVal varname As Integer, ByVal varname As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_set_macro_interruptible Lib "nmlxbib.dll" (ByVal on_off As Byte)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_set_macro_interruptible Lib "fmlxbib.dll" (ByVal on_off As Byte)
#Else
Declare Sub ml8_set_macro_interruptible Lib "wml8bib.dll" (ByVal on_off As Byte)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_allocate_ram Lib "nmlxbib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal strategy As Byte, ByVal align As Byte, size As Long, adr As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_allocate_ram Lib "fmlxbib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal strategy As Byte, ByVal align As Byte, size As Long, adr As Long)
#Else
Declare Sub ml8_allocate_ram Lib "wml8bib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal strategy As Byte, ByVal align As Byte, size As Long, adr As Long)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_get_free_ram Lib "nmlxbib.dll" (ByVal align As Byte, size As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_get_free_ram Lib "fmlxbib.dll" (ByVal align As Byte, size As Long)
#Else
Declare Sub ml8_get_free_ram Lib "wml8bib.dll" (ByVal align As Byte, size As Long)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_transfer_pgm Lib "nmlxbib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal pgmname As String, adr As Long, prepadr As Long, flag As Long) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_transfer_pgm Lib "fmlxbib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal pgmname As String, adr As Long, prepadr As Long, flag As Long) As Integer
#Else
Declare Function ml8_transfer_pgm Lib "wml8bib.dll" (ByVal task As Integer, ByVal usage As Integer, ByVal pgmname As String, adr As Long, prepadr As Long, flag As Long) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_install_task Lib "nmlxbib.dll" (ByVal task As Integer, ByVal prgnum As Integer, ByVal intnum As Integer, ByVal flag As Long, ByVal size As Long, ByVal adr As Long)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_install_task Lib "fmlxbib.dll" (ByVal task As Integer, ByVal prgnum As Integer, ByVal intnum As Integer, ByVal flag As Long, ByVal size As Long, ByVal adr As Long)
#Else
Declare Sub ml8_install_task Lib "wml8bib.dll" (ByVal task As Integer, ByVal prgnum As Integer, ByVal intnum As Integer, ByVal flag As Long, ByVal size As Long, ByVal adr As Long)
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_eeprom_copy Lib "nmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_eeprom_copy Lib "fmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#Else
Declare Function ml8_read_eeprom_copy Lib "wml8bib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#End If


#If PLATFORM = 2 Then
Declare Function ml8_read_eeprom_direct Lib "nmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#ElseIf PLATFORM = 3 Then
Declare Function ml8_read_eeprom_direct Lib "fmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#Else
Declare Function ml8_read_eeprom_direct Lib "wml8bib.dll" (ByVal modul As Byte, ByVal reladr As Byte) As Integer
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_eeprom_copy Lib "nmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_eeprom_copy Lib "fmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#Else
Declare Sub ml8_write_eeprom_copy Lib "wml8bib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_write_eeprom_direct Lib "nmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_write_eeprom_direct Lib "fmlxbib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#Else
Declare Sub ml8_write_eeprom_direct Lib "wml8bib.dll" (ByVal modul As Byte, ByVal reladr As Byte, ByVal data As Integer)
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_local_led_on Lib "nmlxbib.dll" ()
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_local_led_on Lib "fmlxbib.dll" ()
#Else
Declare Sub ml8_local_led_on Lib "wml8bib.dll" ()
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_local_led_off Lib "nmlxbib.dll" ()
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_local_led_off Lib "fmlxbib.dll" ()
#Else
Declare Sub ml8_local_led_off Lib "wml8bib.dll" ()
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_external_led_on Lib "nmlxbib.dll" ()
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_external_led_on Lib "fmlxbib.dll" ()
#Else
Declare Sub ml8_external_led_on Lib "wml8bib.dll" ()
#End If


#If PLATFORM = 2 Then
Declare Sub ml8_external_led_off Lib "nmlxbib.dll" ()
#ElseIf PLATFORM = 3 Then
Declare Sub ml8_external_led_off Lib "fmlxbib.dll" ()
#Else
Declare Sub ml8_external_led_off Lib "wml8bib.dll" ()
#End If


#If PLATFORM = 2 Then
Declare Function ml8_get_local_led_status Lib "nmlxbib.dll" () As Byte
#ElseIf PLATFORM = 3 Then
Declare Function ml8_get_local_led_status Lib "fmlxbib.dll" () As Byte
#Else
Declare Function ml8_get_local_led_status Lib "wml8bib.dll" () As Byte
#End If

